## libaec 0.3.2

=== tests/CMakeLists.txt ===
ADD_LIBRARY(check_aec STATIC check_aec.c)
TARGET_LINK_LIBRARIES(check_aec aec)

ADD_EXECUTABLE(check_code_options check_code_options.c)
TARGET_LINK_LIBRARIES(check_code_options check_aec aec)

ADD_EXECUTABLE(check_buffer_sizes check_buffer_sizes.c)
TARGET_LINK_LIBRARIES(check_buffer_sizes check_aec aec)

ADD_EXECUTABLE(check_long_fs check_long_fs.c)
TARGET_LINK_LIBRARIES(check_long_fs check_aec aec)

ADD_TEST(check_code_options check_code_options)
ADD_TEST(check_buffer_sizes check_buffer_sizes)
ADD_TEST(check_long_fs check_long_fs)

ADD_CUSTOM_TARGET(check COMMAND ${CMAKE_CTEST_COMMAND})
ADD_DEPENDENCIES(check
  check_code_options
  check_buffer_sizes
  check_long_fs)

IF(UNIX)
  ADD_CUSTOM_TARGET(bench
    COMMAND ${CMAKE_SOURCE_DIR}/tests/benc.sh
    COMMAND ${CMAKE_SOURCE_DIR}/tests/bdec.sh
    DEPENDS aec_client utime
    )
ENDIF(UNIX)

=== debian/changelog ===
libaec (0.3.2-1) unstable; urgency=medium

  * Initial release. (Closes: #805936)

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 24 Nov 2015 12:42:30 +0000

=== debian/control ===
Source: libaec
Section: utils
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper (>= 9), dh-buildinfo, autoconf, automake,
 dh-autoreconf, unzip
Standards-Version: 3.9.6
Homepage: https://www.dkrz.de/redmine/projects/aec
Vcs-Git: git://anonscm.debian.org/debian-science/packages/libaec.git

Package: libaec0
Section: libs
Architecture: any
Priority: optional
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Adaptive Entropy Coding library
 Libaec provides fast lossless compression of 1 up to 32 bit wide
 signed or unsigned integers (samples). The library achieves best
 results for low entropy data as often encountered in space imaging
 instrument data or numerical model output from weather or climate
 simulations. While floating point representations are not directly
 supported, they can also be efficiently coded by grouping exponents
 and mantissa.
 .
 Libaec implements Golomb Rice coding as defined in the Space Data
 System Standard documents 121.0-B-2 [1] and 120.0-G-2[2].

Package: libsz2
Section: libs
Architecture: any
Priority: optional
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: Adaptive Entropy Coding library - SZIP
 Libaec provides fast lossless compression of 1 up to 32 bit wide
 signed or unsigned integers (samples). 
 Libaec implements Golomb Rice coding as defined in the Space Data
 System Standard documents 121.0-B-2 [1] and 120.0-G-2[2].
 .
 This package provides a free drop-in replacement for the SZIP
 compression library.

Package: libaec-dev
Section: libdevel
Architecture: any
Priority: extra
Depends: ${misc:Depends}, libaec0 (= ${binary:Version}), libsz2 (= ${binary:Version})
Multi-Arch: same
Description: Development files for the Adaptive Entropy Coding library
 Libaec provides fast lossless compression of 1 up to 32 bit wide
 signed or unsigned integers (samples). The library achieves best
 results for low entropy data as often encountered in space imaging
 instrument data or numerical model output from weather or climate
 simulations. While floating point representations are not directly
 supported, they can also be efficiently coded by grouping exponents
 and mantissa.

Package: libaec-tools
Section: utils
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Adaptive Entropy Coding library (utilies)
 Libaec provides fast lossless compression of 1 up to 32 bit wide
 signed or unsigned integers (samples).
 .
 This package provides the aec compression utility.

=== debian/rules ===
#!/usr/bin/make -f

# The magic debhelper  rule
%:
	dh $@ --with autoreconf

# To enable all, uncomment following line
DEB_BUILD_MAINT_OPTIONS:= hardening=+all
export DEB_BUILD_MAINT_OPTIONS

override_dh_autoreconf:
	dh_autoreconf --as-needed
	cp debian/test-data/* tests

override_dh_auto_clean:
	rm -f tests/*.zip
	dh_auto_clean

## libaec 1.0.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
set(CMAKE_C_STANDARD 99)
include(CheckIncludeFiles)
include(TestBigEndian)
include(CheckCSourceCompiles)
include(CheckSymbolExists)
include(cmake/macros.cmake)
project(libaec)
set(libaec_VERSION_MAJOR 1)
set(libaec_VERSION_MINOR 0)
set(libaec_VERSION_PATCH 2)
set(CMAKE_BUILD_TYPE Release)
enable_testing()

check_include_files(malloc.h HAVE_MALLOC_H)
check_include_files(stdint.h HAVE_STDINT_H)
test_big_endian(WORDS_BIGENDIAN)
check_clzll(HAVE_DECL___BUILTIN_CLZLL)
if(NOT HAVE_DECL___BUILTIN_CLZLL)
  check_bsr64(HAVE_BSR64)
endif(NOT HAVE_DECL___BUILTIN_CLZLL)
find_inline_keyword()
find_restrict_keyword()

check_symbol_exists(snprintf "stdio.h" HAVE_SNPRINTF)
if(NOT HAVE_SNPRINTF)
  check_symbol_exists(_snprintf "stdio.h" HAVE__SNPRINTF)
  check_symbol_exists(_snprintf_s "stdio.h" HAVE__SNPRINTF_S)
endif(NOT HAVE_SNPRINTF)

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/cmake/config.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/config.h)
add_definitions("-DHAVE_CONFIG_H")

option(BUILD_SHARED_LIBS "Build Shared Libraries" ON)
if(BUILD_SHARED_LIBS)
  set (LIB_TYPE SHARED)
else(BUILD_SHARED_LIBS)
  if(WIN32)
    message(WARNING "You will have to modify libaec.h for static libs.")
  endif(WIN32)
  set(LIB_TYPE STATIC)
endif(BUILD_SHARED_LIBS)

set(libaec_SRCS
  ${PROJECT_SOURCE_DIR}/src/encode.c
  ${PROJECT_SOURCE_DIR}/src/encode_accessors.c
  ${PROJECT_SOURCE_DIR}/src/decode.c)

include_directories("${PROJECT_BINARY_DIR}")
include_directories("${PROJECT_SOURCE_DIR}/src")

add_subdirectory(src)
add_subdirectory(tests)

option(AEC_FUZZING "Enable build of fuzzing targets" OFF)
if(AEC_FUZZING)
  add_subdirectory(fuzzing)
endif()

set(CPACK_PACKAGE_NAME "libaec")
set(CPACK_PACKAGE_VENDOR "Deutsches Klimarechenzentrum GmbH")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY
  "libaec - Adaptive Entropy Coding library")
set(CPACK_PACKAGE_VERSION_MAJOR "${libaec_VERSION_MAJOR}")
set(CPACK_PACKAGE_VERSION_MINOR "${libaec_VERSION_MINOR}")
set(CPACK_PACKAGE_VERSION_PATCH "${libaec_VERSION_PATCH}")
set(CPACK_PACKAGE_INSTALL_DIRECTORY "libaec")
set(CPACK_RESOURCE_FILE_LICENSE "${PROJECT_SOURCE_DIR}/Copyright.txt")

if(WIN32)
  set(CPACK_GENERATOR "WIX")
  set(CPACK_WIX_UPGRADE_GUID "E58A21F6-BB99-46B5-8AD8-6114E4CCA0A6")
  if(CMAKE_CL_64)
    set(CPACK_INSTALL_DIRECTORY "$PROGRAMFILES64")
    set(CPACK_PACKAGE_INSTALL_REGISTRY_KEY
      "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION} (Win64)")
  else(CMAKE_CL_64)
    set(CPACK_INSTALL_DIRECTORY "$PROGRAMFILES")
    set(CPACK_PACKAGE_INSTALL_REGISTRY_KEY
      "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION}")
  endif(CMAKE_CL_64)
endif(WIN32)

include(CPack)

=== debian/changelog ===
libaec (1.0.2-1) unstable; urgency=medium

  * New upstream release
  * Minor version moves libaec.0.0.3 -> 0.0.8
  * Change homepage to gitlab.dkrz.de
  * Standards-Verson: 4.1.3; no change required
  * Point VCS to salsa.debian.org
  * Drop Priority: extra. Now optional

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 02 Mar 2018 14:06:21 +0000

libaec (0.3.2-2) unstable; urgency=medium

  * Standards-Version: 4.0.0; no changes required
  * DH_COMPAT now 10
  * Remove redundant auto*, dh-autoreconf build-deps
  * Add debian/gbp.conf file

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 28 Jul 2017 15:17:29 +0100

libaec (0.3.2-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 05 Jan 2016 13:06:14 +0000

=== debian/control ===
--- 
+++ 
@@ -2,11 +2,13 @@
 Section: utils
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
-Build-Depends: debhelper (>= 9), dh-buildinfo, autoconf, automake,
- dh-autoreconf, unzip
-Standards-Version: 3.9.6
-Homepage: https://www.dkrz.de/redmine/projects/aec
-Vcs-Git: git://anonscm.debian.org/debian-science/packages/libaec.git
+Build-Depends: debhelper (>= 10), 
+ dh-buildinfo, 
+ unzip
+Standards-Version: 4.1.3
+Homepage:  https://gitlab.dkrz.de/k202009/libaec
+Vcs-Browser: https://salsa.debian.org:/science-team/libaec.git
+Vcs-Git: https://salsa.debian.org:/science-team/libaec.git
 
 Package: libaec0
 Section: libs
@@ -46,7 +48,6 @@
 Package: libaec-dev
 Section: libdevel
 Architecture: any
-Priority: extra
 Depends: ${misc:Depends}, libaec0 (= ${binary:Version}), libsz2 (= ${binary:Version})
 Multi-Arch: same
 Description: Development files for the Adaptive Entropy Coding library

## libaec 1.0.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,15 +5,21 @@
 include(CheckCSourceCompiles)
 include(CheckSymbolExists)
 include(cmake/macros.cmake)
-project(libaec)
+
+option(AEC_FUZZING "Enable build of fuzzing targets" OFF)
+if(AEC_FUZZING)
+  project(libaec C CXX)
+else(AEC_FUZZING)
+  project(libaec C)
+endif(AEC_FUZZING)
+
 set(libaec_VERSION_MAJOR 1)
 set(libaec_VERSION_MINOR 0)
-set(libaec_VERSION_PATCH 2)
+set(libaec_VERSION_PATCH 4)
 set(CMAKE_BUILD_TYPE Release)
 enable_testing()
 
 check_include_files(malloc.h HAVE_MALLOC_H)
-check_include_files(stdint.h HAVE_STDINT_H)
 test_big_endian(WORDS_BIGENDIAN)
 check_clzll(HAVE_DECL___BUILTIN_CLZLL)
 if(NOT HAVE_DECL___BUILTIN_CLZLL)
@@ -53,8 +59,6 @@
 
 add_subdirectory(src)
 add_subdirectory(tests)
-
-option(AEC_FUZZING "Enable build of fuzzing targets" OFF)
 if(AEC_FUZZING)
   add_subdirectory(fuzzing)
 endif()

=== fuzzing/CMakeLists.txt ===
if(NOT CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  message(FATAL_ERROR "You need to build with Clang for fuzzing to work")
endif()

add_library(aec_fuzz STATIC ${libaec_SRCS})
add_executable(fuzz_target fuzz_target.cc)

set(FUZZ_TARGET_LINK_FLAGS "-fsanitize=address,undefined")
set(FUZZ_TARGET_COMPILE_FLAGS
  "-g"
  "-fsanitize=address,undefined"
  "-fno-sanitize-recover=undefined"
  "-fsanitize-coverage=trace-pc-guard,indirect-calls,edge")
set_target_properties(fuzz_target aec_fuzz PROPERTIES
  LINK_FLAGS ${FUZZ_TARGET_LINK_FLAGS}
  COMPILE_OPTIONS "${FUZZ_TARGET_COMPILE_FLAGS}")

target_link_libraries(fuzz_target aec_fuzz Fuzzer)

=== src/CMakeLists.txt ===
add_library(aec ${LIB_TYPE} ${libaec_SRCS})
set_target_properties(aec PROPERTIES VERSION 0.0.10 SOVERSION 0)
add_library(sz ${LIB_TYPE} sz_compat.c)
set_target_properties(sz PROPERTIES VERSION 2.0.1 SOVERSION 2)

target_link_libraries(sz aec)
if(WIN32 AND BUILD_SHARED_LIBS)
  set_target_properties (aec PROPERTIES DEFINE_SYMBOL "BUILDING_LIBAEC")
  set_target_properties (sz PROPERTIES DEFINE_SYMBOL "BUILDING_LIBAEC")
  set_target_properties(sz PROPERTIES OUTPUT_NAME "szip")
endif(WIN32 AND BUILD_SHARED_LIBS)

add_executable(aec_client aec.c)
set_target_properties(aec_client PROPERTIES OUTPUT_NAME "aec")
target_link_libraries(aec_client aec)

if(UNIX)
  add_executable(utime EXCLUDE_FROM_ALL utime.c)
  add_custom_target(bench
    COMMAND ${CMAKE_SOURCE_DIR}/src/benc.sh ${CMAKE_SOURCE_DIR}/data/typical.rz
    COMMAND ${CMAKE_SOURCE_DIR}/src/bdec.sh
    DEPENDS aec_client utime)
endif(UNIX)

include(GNUInstallDirs)
if(WIN32)
  install(TARGETS aec sz
    RUNTIME
    DESTINATION bin
    ARCHIVE
    DESTINATION lib
    COMPONENT libraries)
else(WIN32)
  install(TARGETS aec sz
    LIBRARY
    DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE
    DESTINATION ${CMAKE_INSTALL_LIBDIR}
    COMPONENT libraries)
  install(FILES aec.1
    DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man1 COMPONENT doc)
endif(WIN32)

install(FILES libaec.h szlib.h
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  COMPONENT headers)
install(TARGETS aec_client
  RUNTIME
  DESTINATION ${CMAKE_INSTALL_BINDIR}
  COMPONENT applications)

set(CPACK_COMPONENTS_ALL applications libraries headers doc)

=== tests/CMakeLists.txt ===
add_library(check_aec STATIC check_aec.c)

add_executable(check_code_options check_code_options.c)
target_link_libraries(check_code_options check_aec aec)
add_test(NAME check_code_options COMMAND check_code_options)
add_executable(check_buffer_sizes check_buffer_sizes.c)
target_link_libraries(check_buffer_sizes check_aec aec)
add_test(NAME check_buffer_sizes COMMAND check_buffer_sizes)
add_executable(check_long_fs check_long_fs.c)
target_link_libraries(check_long_fs check_aec aec)
add_test(NAME check_long_fs COMMAND check_long_fs)
add_executable(check_szcomp check_szcomp.c)
target_link_libraries(check_szcomp check_aec sz)
add_test(NAME check_szcomp
  COMMAND check_szcomp ${PROJECT_SOURCE_DIR}/data/121B2TestData/ExtendedParameters/sar32bit.dat)

if(UNIX)
  add_test(
    NAME sampledata.sh
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/sampledata.sh ${CMAKE_CURRENT_SOURCE_DIR}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

  set(SAMPLE_DATA_DIR "${PROJECT_SOURCE_DIR}/data")
  set(SAMPLE_DATA_NAME "121B2TestData")
  set(SAMPLE_DATA_URL "https://cwe.ccsds.org/sls/docs/SLS-DC/BB121B2TestData/121B2TestData.zip")
  add_custom_target(
    update-sampledata
    WORKING_DIRECTORY ${SAMPLE_DATA_DIR}
    COMMAND rm -rf ${SAMPLE_DATA_NAME}
    COMMAND curl ${SAMPLE_DATA_URL} -O
    COMMAND unzip "${SAMPLE_DATA_NAME}.zip"
    COMMAND rm -f "${SAMPLE_DATA_NAME}.zip"
    COMMAND mv -f "${SAMPLE_DATA_NAME}/AllOptions/test_P512n22.dat"
    "${SAMPLE_DATA_NAME}/AllOptions/test_p512n22.dat")
endif(UNIX)

=== debian/changelog ===
libaec (1.0.4-1) unstable; urgency=medium

  * New upstream release
  * Minor version move libaec 0.0.8 -> 0.0.10
  * Standards-Version: 4.4.0
  * Use debhelper-compat (=12)
  * Add d/watch file

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 19 Jul 2019 13:54:12 +0100

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Section: utils
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
-Build-Depends: debhelper (>= 10), 
+Build-Depends: debhelper-compat (= 12), 
  dh-buildinfo, 
  unzip
-Standards-Version: 4.1.3
+Standards-Version: 4.4.0
 Homepage:  https://gitlab.dkrz.de/k202009/libaec
 Vcs-Browser: https://salsa.debian.org:/science-team/libaec.git
 Vcs-Git: https://salsa.debian.org:/science-team/libaec.git

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/libaec-$1\.tar\.gz/ \
  https://github.com/MathisRosenhauer/libaec/tags .*/v?(\d\S+)\.tar\.gz

## libaec 1.0.6

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13...3.19)
project(libaec LANGUAGES C VERSION 1.0.6)

# Automatically export symbols for Windows DLLs
set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_VISIBILITY_PRESET hidden)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
include(CTest)

include(TestBigEndian)
test_big_endian(WORDS_BIGENDIAN)

# Check for __builtin_clzll for faster decoding
include(CheckCSourceCompiles)
check_c_source_compiles(
  "int main(void)\n{return __builtin_clzll(1LL);}"
  HAVE_DECL___BUILTIN_CLZLL)

if(NOT HAVE_DECL___BUILTIN_CLZLL)
  # With MSVC we can use _BitScanReverse64
  check_c_source_compiles(
    "int main(void){unsigned long foo; unsigned __int64 bar=1LL;
return _BitScanReverse64(&foo, bar);}"
    HAVE_BSR64)
endif()

include(CheckSymbolExists)
check_symbol_exists(snprintf "stdio.h" HAVE_SNPRINTF)
if(NOT HAVE_SNPRINTF)
  check_symbol_exists(_snprintf "stdio.h" HAVE__SNPRINTF)
  check_symbol_exists(_snprintf_s "stdio.h" HAVE__SNPRINTF_S)
endif()

# Communicate findings to code. Has to be compatible with autoconf's config.h.
configure_file(
  "cmake/config.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/config.h")

add_subdirectory(src)
if(BUILD_TESTING)
  add_subdirectory(tests)
endif()

option(AEC_FUZZING "Enable build of fuzzing target" OFF)
if(AEC_FUZZING)
  enable_language(CXX)

  if(NOT CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    message(FATAL_ERROR "You need to build with Clang for fuzzing to work")
  endif()

  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "6.0.0")
    message(FATAL_ERROR "You need Clang ≥ 6.0.0")
  endif()

  add_subdirectory(fuzzing)
  set(FUZZ_TARGET_SAN_FLAGS -fsanitize=fuzzer-no-link,address,undefined)
  target_compile_options(aec PUBLIC -g -O1 ${FUZZ_TARGET_SAN_FLAGS})
  target_link_options(aec PUBLIC ${FUZZ_TARGET_SAN_FLAGS})
endif()

# Install the cmake files.
set(libaec_CONFIG_IN  ${CMAKE_CURRENT_SOURCE_DIR}/cmake/libaec-config.cmake.in)
set(libaec_CONFIG_OUT ${CMAKE_CURRENT_BINARY_DIR}/cmake/libaec-config.cmake)
configure_file(${libaec_CONFIG_IN} ${libaec_CONFIG_OUT} @ONLY)
set(libaec_CONFIG_VERSION_IN  ${CMAKE_CURRENT_SOURCE_DIR}/cmake/libaec-config-version.cmake.in)
set(libaec_CONFIG_VERSION_OUT ${CMAKE_CURRENT_BINARY_DIR}/cmake/libaec-config-version.cmake)
configure_file(${libaec_CONFIG_VERSION_IN} ${libaec_CONFIG_VERSION_OUT} @ONLY)
install(FILES ${libaec_CONFIG_OUT}
        DESTINATION cmake)
install(FILES ${libaec_CONFIG_VERSION_OUT}
        DESTINATION cmake)

# Cpack configuration mainly for Windows installer
set(CPACK_PACKAGE_NAME "libaec")
set(CPACK_PACKAGE_VENDOR "Deutsches Klimarechenzentrum GmbH")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY
  "libaec - Adaptive Entropy Coding library")
set(CPACK_PACKAGE_INSTALL_DIRECTORY "libaec")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE.txt")

if(WIN32)
  set(CPACK_GENERATOR "WIX")
  set(CPACK_WIX_UPGRADE_GUID "E58A21F6-BB99-46B5-8AD8-6114E4CCA0A6")
endif()

set(CPACK_SOURCE_IGNORE_FILES
    /.git
    /.*build.*
    .*~
    .*\#.*\#
    \..*\#.*)

include(CPack)

=== src/CMakeLists.txt ===
# Main library aec
add_library(aec OBJECT
  encode.c
  encode_accessors.c
  decode.c)

target_include_directories(aec
  PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>"
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/..>"
  "$<INSTALL_INTERFACE:include>")

# Create both static and shared aec library.
add_library(aec_static STATIC "$<TARGET_OBJECTS:aec>")
target_link_libraries(aec_static PUBLIC aec)
set_target_properties(aec_static
  PROPERTIES
  OUTPUT_NAME $<IF:$<BOOL:${MSVC}>,aec-static,aec>)

add_library(aec_shared SHARED "$<TARGET_OBJECTS:aec>")
target_link_libraries(aec_shared PUBLIC aec)
set_target_properties(aec_shared
  PROPERTIES
  VERSION 0.0.12
  SOVERSION 0
  OUTPUT_NAME aec
  PUBLIC_HEADER ../include/libaec.h)

# Wrapper for compatibility with szip
add_library(sz OBJECT sz_compat.c)
target_link_libraries(sz PUBLIC aec)

# Create both static and shared szip library.
add_library(sz_static STATIC "$<TARGET_OBJECTS:sz>" "$<TARGET_OBJECTS:aec>")
set_target_properties(sz_static
  PROPERTIES
  OUTPUT_NAME $<IF:$<BOOL:${MSVC}>,szip-static,sz>)
target_link_libraries(sz_static PUBLIC sz)

add_library(sz_shared SHARED "$<TARGET_OBJECTS:sz>" "$<TARGET_OBJECTS:aec>")
target_link_libraries(sz_shared PUBLIC sz)
set_target_properties(sz_shared
  PROPERTIES
  VERSION 2.0.1
  SOVERSION 2
  OUTPUT_NAME $<IF:$<BOOL:${MSVC}>,szip,sz>
  PUBLIC_HEADER ../include/szlib.h)

# Simple client for testing and benchmarking.
# Can also be used stand-alone
add_executable(aec_client aec.c)
set_target_properties(aec_client PROPERTIES OUTPUT_NAME aec)
target_link_libraries(aec_client PUBLIC aec)

include(GNUInstallDirs)
if(UNIX)
  # Handle visibility of symbols. Compatible with gnulib's gl_VISIBILITY
  include(CheckCCompilerFlag)
  check_c_compiler_flag(-fvisibility=hidden COMPILER_HAS_HIDDEN_VISIBILITY)
  set_target_properties(aec sz
    PROPERTIES
    COMPILE_DEFINITIONS
    "HAVE_VISIBILITY=$<BOOL:${COMPILER_HAS_HIDDEN_VISIBILITY}>;BUILDING_LIBAEC")

  # The shell scripts for benchmarking are supported on unix only
  add_executable(utime EXCLUDE_FROM_ALL utime.c)
  target_include_directories(utime PRIVATE "${CMAKE_CURRENT_BINARY_DIR}/..")
  add_custom_target(bench
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/benc.sh
    ${CMAKE_CURRENT_SOURCE_DIR}/../data/typical.rz
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/bdec.sh
    DEPENDS aec_client utime)
endif()

if(UNIX OR MINGW)
  # Install manpage
  install(
    FILES aec.1
    DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man1
    COMPONENT doc)
endif()

install(TARGETS aec_static aec_shared sz_static sz_shared aec_client)

=== tests/CMakeLists.txt ===
add_library(check_aec STATIC check_aec.c)
target_link_libraries(check_aec PUBLIC aec)
add_executable(check_code_options check_code_options.c)
target_link_libraries(check_code_options PUBLIC check_aec aec)
add_test(NAME check_code_options COMMAND check_code_options)
add_executable(check_buffer_sizes check_buffer_sizes.c)
target_link_libraries(check_buffer_sizes PUBLIC check_aec aec)
add_test(NAME check_buffer_sizes COMMAND check_buffer_sizes)
add_executable(check_long_fs check_long_fs.c)
target_link_libraries(check_long_fs PUBLIC check_aec aec)
add_test(NAME check_long_fs COMMAND check_long_fs)
add_executable(check_szcomp check_szcomp.c)
target_link_libraries(check_szcomp PUBLIC check_aec sz)
add_test(NAME check_szcomp
  COMMAND check_szcomp ${PROJECT_SOURCE_DIR}/data/121B2TestData/ExtendedParameters/sar32bit.dat)

if(UNIX)
  add_test(
    NAME sampledata.sh
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/sampledata.sh
    ${CMAKE_CURRENT_SOURCE_DIR}
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

  set(SAMPLE_DATA_DIR "${CMAKE_CURRENT_SOURCE_DIR}/../data")
  set(SAMPLE_DATA_NAME "121B2TestData")
  set(SAMPLE_DATA_URL "https://cwe.ccsds.org/sls/docs/SLS-DC/BB121B2TestData/121B2TestData.zip")
  add_custom_target(
    update-sampledata
    WORKING_DIRECTORY ${SAMPLE_DATA_DIR}
    COMMAND rm -rf ${SAMPLE_DATA_NAME}
    COMMAND curl ${SAMPLE_DATA_URL} -O
    COMMAND unzip "${SAMPLE_DATA_NAME}.zip"
    COMMAND rm -f "${SAMPLE_DATA_NAME}.zip"
    COMMAND mv -f "${SAMPLE_DATA_NAME}/AllOptions/test_P512n22.dat"
    "${SAMPLE_DATA_NAME}/AllOptions/test_p512n22.dat")
endif(UNIX)

=== debian/changelog ===
libaec (1.0.6-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.6.0

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 22 Sep 2021 08:55:12 +0100

libaec (1.0.5-2) unstable; urgency=medium

  * Push to unstable

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 16 Aug 2021 05:07:04 +0100

libaec (1.0.5-1) experimental; urgency=medium

  * New upstream release
  * Move to debhelper-compat level 13
  * Standards-Version: 4.5.1
  * Move to DEP-14 branch names, update gpb.conf and Vcs-Git
  * libaec now 0.0.11

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 21 Jun 2021 09:19:17 +0100

libaec (1.0.4-3) unstable; urgency=medium

  * Team upload.
  * Drop the Breaks again, co-installability of hdf5 and gdal libraries from
    buster and bullseye has been restored.
  * Drop redundant fields and options.
  * Set Rules-Requires-Root: no.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 14 Jun 2021 12:03:25 +0200

libaec (1.0.4-2) unstable; urgency=medium

  * Team upload.
  * libsz2: Add 'Breaks: libhdf5-103, libhdf5-mpich-103, libhdf5-openmpi-103,
    libnetcdf13, libgdal20' for smoother upgrades from buster.

 -- Andreas Beckmann <anbe@debian.org>  Mon, 26 Apr 2021 16:54:22 +0200

=== debian/control ===
--- 
+++ 
@@ -2,18 +2,18 @@
 Section: utils
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
-Build-Depends: debhelper-compat (= 12), 
- dh-buildinfo, 
+Build-Depends: debhelper-compat (= 13),
+ dh-buildinfo,
  unzip
-Standards-Version: 4.4.0
-Homepage:  https://gitlab.dkrz.de/k202009/libaec
-Vcs-Browser: https://salsa.debian.org:/science-team/libaec.git
-Vcs-Git: https://salsa.debian.org:/science-team/libaec.git
+Rules-Requires-Root: no
+Standards-Version: 4.6.0
+Homepage: https://gitlab.dkrz.de/k202009/libaec
+Vcs-Browser: https://salsa.debian.org/science-team/libaec
+Vcs-Git: https://salsa.debian.org/science-team/libaec.git -b debian/latest
 
 Package: libaec0
 Section: libs
 Architecture: any
-Priority: optional
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Multi-Arch: same
@@ -32,13 +32,12 @@
 Package: libsz2
 Section: libs
 Architecture: any
-Priority: optional
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Pre-Depends: ${misc:Pre-Depends}
 Multi-Arch: same
 Description: Adaptive Entropy Coding library - SZIP
  Libaec provides fast lossless compression of 1 up to 32 bit wide
- signed or unsigned integers (samples). 
+ signed or unsigned integers (samples).
  Libaec implements Golomb Rice coding as defined in the Space Data
  System Standard documents 121.0-B-2 [1] and 120.0-G-2[2].
  .
@@ -60,10 +59,9 @@
  and mantissa.
 
 Package: libaec-tools
-Section: utils
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Description: Adaptive Entropy Coding library (utilies)
+Description: Adaptive Entropy Coding library (utilities)
  Libaec provides fast lossless compression of 1 up to 32 bit wide
  signed or unsigned integers (samples).
  .

## libaec 1.1.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.13...3.19)
-project(libaec LANGUAGES C VERSION 1.0.6)
+project(libaec LANGUAGES C VERSION 1.1.2)
 
 # Automatically export symbols for Windows DLLs
 set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)
@@ -36,7 +36,12 @@
 # Communicate findings to code. Has to be compatible with autoconf's config.h.
 configure_file(
   "cmake/config.h.in"
-  "${CMAKE_CURRENT_BINARY_DIR}/config.h")
+  "${CMAKE_CURRENT_BINARY_DIR}/include/config.h")
+
+# Create libaec.h with current version information
+configure_file(
+  "include/libaec.h.in"
+  "${CMAKE_CURRENT_BINARY_DIR}/include/libaec.h")
 
 add_subdirectory(src)
 if(BUILD_TESTING)
@@ -89,6 +94,7 @@
 set(CPACK_SOURCE_IGNORE_FILES
     /.git
     /.*build.*
+    /*.cache
     .*~
     .*\#.*\#
     \..*\#.*)

=== fuzzing/CMakeLists.txt ===
add_executable(fuzz_target fuzz_target.cc)
target_link_libraries(fuzz_target aec)

# Actually link libFuzzer
target_link_options(fuzz_target PRIVATE -fsanitize=fuzzer)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -2,12 +2,13 @@
 add_library(aec OBJECT
   encode.c
   encode_accessors.c
-  decode.c)
+  decode.c
+  vector.c)
 
 target_include_directories(aec
   PUBLIC
   "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>"
-  "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/..>"
+  "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/../include>"
   "$<INSTALL_INTERFACE:include>")
 
 # Create both static and shared aec library.
@@ -21,10 +22,10 @@
 target_link_libraries(aec_shared PUBLIC aec)
 set_target_properties(aec_shared
   PROPERTIES
-  VERSION 0.0.12
+  VERSION 0.1.2
   SOVERSION 0
   OUTPUT_NAME aec
-  PUBLIC_HEADER ../include/libaec.h)
+  PUBLIC_HEADER ${CMAKE_CURRENT_BINARY_DIR}/../include/libaec.h)
 
 # Wrapper for compatibility with szip
 add_library(sz OBJECT sz_compat.c)
@@ -46,11 +47,9 @@
   OUTPUT_NAME $<IF:$<BOOL:${MSVC}>,szip,sz>
   PUBLIC_HEADER ../include/szlib.h)
 
-# Simple client for testing and benchmarking.
-# Can also be used stand-alone
-add_executable(aec_client aec.c)
-set_target_properties(aec_client PROPERTIES OUTPUT_NAME aec)
-target_link_libraries(aec_client PUBLIC aec)
+# Simple executable for testing and benchmarking.
+add_executable(graec graec.c)
+target_link_libraries(graec aec)
 
 include(GNUInstallDirs)
 if(UNIX)
@@ -69,6 +68,7 @@
     COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/benc.sh
     ${CMAKE_CURRENT_SOURCE_DIR}/../data/typical.rz
     COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/bdec.sh
+<<<<<<< HEAD
     DEPENDS aec_client utime)
 endif()
 
@@ -78,6 +78,9 @@
     FILES aec.1
     DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man1
     COMPONENT doc)
+=======
+    DEPENDS graec utime)
+>>>>>>> upstream/1.1.1
 endif()
 
-install(TARGETS aec_static aec_shared sz_static sz_shared aec_client)
+install(TARGETS aec_static aec_shared sz_static sz_shared)

=== debian/changelog ===
libaec (1.1.2-1build1) noble; urgency=high

  * No change rebuild for frame pointers (and time_t).

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 18 Apr 2024 19:49:57 +0200

libaec (1.1.2-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 06 Oct 2023 09:18:51 +0100

libaec (1.1.1-1) unstable; urgency=medium

  * New upstream release
  * No longer ship tools pkg; now considered internal-only by upstream.
  * libaec.so.0.0.1 -> libaec.so.0.1.1
  * Standards-Version: 4.6.2

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 02 Oct 2023 07:23:50 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: libaec
 Section: utils
 Priority: optional
-Maintainer: Alastair McKinstry <mckinstry@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Alastair McKinstry <mckinstry@debian.org>
 Build-Depends: debhelper-compat (= 13),
  dh-buildinfo,
  unzip
 Rules-Requires-Root: no
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Homepage: https://gitlab.dkrz.de/k202009/libaec
 Vcs-Browser: https://salsa.debian.org/science-team/libaec
 Vcs-Git: https://salsa.debian.org/science-team/libaec.git -b debian/latest
@@ -57,12 +58,3 @@
  simulations. While floating point representations are not directly
  supported, they can also be efficiently coded by grouping exponents
  and mantissa.
-
-Package: libaec-tools
-Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}
-Description: Adaptive Entropy Coding library (utilities)
- Libaec provides fast lossless compression of 1 up to 32 bit wide
- signed or unsigned integers (samples).
- .
- This package provides the aec compression utility.

## libaec 1.1.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,8 +1,5 @@
 cmake_minimum_required(VERSION 3.13...3.19)
-project(libaec LANGUAGES C VERSION 1.1.2)
-
-# Automatically export symbols for Windows DLLs
-set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)
+project(libaec LANGUAGES C VERSION 1.1.3)
 
 set(CMAKE_C_STANDARD 99)
 set(CMAKE_C_VISIBILITY_PRESET hidden)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -22,7 +22,7 @@
 target_link_libraries(aec_shared PUBLIC aec)
 set_target_properties(aec_shared
   PROPERTIES
-  VERSION 0.1.2
+  VERSION 0.1.3
   SOVERSION 0
   OUTPUT_NAME aec
   PUBLIC_HEADER ${CMAKE_CURRENT_BINARY_DIR}/../include/libaec.h)
@@ -30,6 +30,8 @@
 # Wrapper for compatibility with szip
 add_library(sz OBJECT sz_compat.c)
 target_link_libraries(sz PUBLIC aec)
+
+set(libaec_COMPILE_DEFINITIONS "LIBAEC_BUILD;LIBAEC_SHARED")
 
 # Create both static and shared szip library.
 add_library(sz_static STATIC "$<TARGET_OBJECTS:sz>" "$<TARGET_OBJECTS:aec>")
@@ -51,16 +53,14 @@
 add_executable(graec graec.c)
 target_link_libraries(graec aec)
 
+# Handle visibility of symbols. Compatible with gnulib's gl_VISIBILITY
+include(CheckCCompilerFlag)
+check_c_compiler_flag(-fvisibility=hidden COMPILER_HAS_HIDDEN_VISIBILITY)
+set(libaec_COMPILE_DEFINITIONS
+  "${libaec_COMPILE_DEFINITIONS};HAVE_VISIBILITY=$<BOOL:${COMPILER_HAS_HIDDEN_VISIBILITY}>")
+
 include(GNUInstallDirs)
 if(UNIX)
-  # Handle visibility of symbols. Compatible with gnulib's gl_VISIBILITY
-  include(CheckCCompilerFlag)
-  check_c_compiler_flag(-fvisibility=hidden COMPILER_HAS_HIDDEN_VISIBILITY)
-  set_target_properties(aec sz
-    PROPERTIES
-    COMPILE_DEFINITIONS
-    "HAVE_VISIBILITY=$<BOOL:${COMPILER_HAS_HIDDEN_VISIBILITY}>;BUILDING_LIBAEC")
-
   # The shell scripts for benchmarking are supported on unix only
   add_executable(utime EXCLUDE_FROM_ALL utime.c)
   target_include_directories(utime PRIVATE "${CMAKE_CURRENT_BINARY_DIR}/..")
@@ -83,4 +83,8 @@
 >>>>>>> upstream/1.1.1
 endif()
 
+set_target_properties(aec sz
+  PROPERTIES
+  COMPILE_DEFINITIONS "${libaec_COMPILE_DEFINITIONS}")
+
 install(TARGETS aec_static aec_shared sz_static sz_shared)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,18 +1,28 @@
 add_library(check_aec STATIC check_aec.c)
 target_link_libraries(check_aec PUBLIC aec)
+
 add_executable(check_code_options check_code_options.c)
 target_link_libraries(check_code_options PUBLIC check_aec aec)
 add_test(NAME check_code_options COMMAND check_code_options)
+
 add_executable(check_buffer_sizes check_buffer_sizes.c)
 target_link_libraries(check_buffer_sizes PUBLIC check_aec aec)
 add_test(NAME check_buffer_sizes COMMAND check_buffer_sizes)
+add_executable(check_seeking check_seeking.c)
+target_link_libraries(check_seeking PUBLIC check_aec aec)
+add_test(NAME check_seeking COMMAND check_seeking)
 add_executable(check_long_fs check_long_fs.c)
 target_link_libraries(check_long_fs PUBLIC check_aec aec)
 add_test(NAME check_long_fs COMMAND check_long_fs)
+
 add_executable(check_szcomp check_szcomp.c)
 target_link_libraries(check_szcomp PUBLIC check_aec sz)
 add_test(NAME check_szcomp
   COMMAND check_szcomp ${PROJECT_SOURCE_DIR}/data/121B2TestData/ExtendedParameters/sar32bit.dat)
+
+add_executable(check_rsi_block_access check_rsi_block_access.c)
+target_link_libraries(check_rsi_block_access PUBLIC check_aec aec)
+add_test(NAME check_rsi_block_access COMMAND check_rsi_block_access)
 
 if(UNIX)
   add_test(

=== debian/changelog ===
libaec (1.1.3-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 22 Mar 2024 08:50:51 +0000

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: libaec
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Alastair McKinstry <mckinstry@debian.org>
+Maintainer: Alastair McKinstry <mckinstry@debian.org>
 Build-Depends: debhelper-compat (= 13),
  dh-buildinfo,
  unzip

## libaec 1.1.4

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.26...3.31)
project(libaec LANGUAGES C VERSION 1.1.4)

option(BUILD_SHARED_LIBS "OFF: do not build shared libraries.  ON (default): build shared libraries" ON)
option(BUILD_STATIC_LIBS "OFF: do not build static libraries.  ON (default): build static libraries" ON)

set(CMAKE_C_STANDARD 99)
set(CMAKE_C_VISIBILITY_PRESET hidden)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
include(CTest)
include(TestBigEndian)
test_big_endian(WORDS_BIGENDIAN)

# Check for __builtin_clzll for faster decoding
include(CheckCSourceCompiles)
check_c_source_compiles(
  "int main(void)\n{return __builtin_clzll(1LL);}"
  HAVE_DECL___BUILTIN_CLZLL)

if(NOT HAVE_DECL___BUILTIN_CLZLL)
  # With MSVC we can use _BitScanReverse64
  check_c_source_compiles(
    "int main(void){unsigned long foo; unsigned __int64 bar=1LL;
return _BitScanReverse64(&foo, bar);}"
    HAVE_BSR64)
endif()

include(CheckSymbolExists)
check_symbol_exists(snprintf "stdio.h" HAVE_SNPRINTF)
if(NOT HAVE_SNPRINTF)
  check_symbol_exists(_snprintf "stdio.h" HAVE__SNPRINTF)
  check_symbol_exists(_snprintf_s "stdio.h" HAVE__SNPRINTF_S)
endif()

# Communicate findings to code. Has to be compatible with autoconf's config.h.
configure_file(
  "include/config.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/include/config.h")

# Create libaec.h with current version information
configure_file(
  "include/libaec.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/include/libaec.h")

add_subdirectory(src)
if(BUILD_TESTING)
  add_subdirectory(tests)
endif()

option(AEC_FUZZING "Enable build of fuzzing target" OFF)
if(AEC_FUZZING)
  enable_language(CXX)

  if(NOT CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    message(FATAL_ERROR "You need to build with Clang for fuzzing to work")
  endif()

  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS "6.0.0")
    message(FATAL_ERROR "You need Clang ≥ 6.0.0")
  endif()

  add_subdirectory(fuzzing)
  set(FUZZ_TARGET_SAN_FLAGS -fsanitize=fuzzer-no-link,address,undefined)
  target_compile_options(aec PUBLIC -g -O1 ${FUZZ_TARGET_SAN_FLAGS})
  target_link_options(aec PUBLIC ${FUZZ_TARGET_SAN_FLAGS})
endif()

# Include the install rules if the user wanted them (included by
# default when top-level)

string(COMPARE
  EQUAL "${CMAKE_SOURCE_DIR}" "${CMAKE_CURRENT_SOURCE_DIR}" is_top_level)
option(libaec_INCLUDE_PACKAGING
  "Include packaging rules for libaec" "${is_top_level}")
if(libaec_INCLUDE_PACKAGING)
  add_subdirectory(packaging)
endif()

=== packaging/CMakeLists.txt ===
include(GNUInstallDirs)
include(CMakePackageConfigHelpers)

if(NOT DEFINED libaec_INSTALL_CMAKEDIR)
  set(libaec_INSTALL_CMAKEDIR "${CMAKE_INSTALL_LIBDIR}/cmake/libaec"
    CACHE STRING "Path to libaec CMake files")
endif()

write_basic_package_version_file(
  libaec-config-version.cmake
  COMPATIBILITY SameMajorVersion)

install(FILES
  "${CMAKE_CURRENT_SOURCE_DIR}/libaec-config.cmake"
  "${CMAKE_CURRENT_BINARY_DIR}/libaec-config-version.cmake"
  DESTINATION "${libaec_INSTALL_CMAKEDIR}")

set(TARGETS_EXPORT)
if(BUILD_SHARED_LIBS)
  set(TARGETS_EXPORT aec-shared-objects sz-shared-objects aec-shared sz-shared)
endif()
if(BUILD_STATIC_LIBS)
  set(TARGETS_EXPORT
    ${TARGETS_EXPORT}
    aec-static-objects sz-static-objects aec-static sz-static)
endif()

install(TARGETS ${TARGETS_EXPORT}
  EXPORT libaec_targets
  PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")

install(EXPORT libaec_targets
  DESTINATION "${libaec_INSTALL_CMAKEDIR}"
  NAMESPACE libaec::
  FILE libaec-targets.cmake)

# Cpack configuration mainly for Windows installer
set(CPACK_PACKAGE_NAME "libaec")
set(CPACK_PACKAGE_VENDOR "Deutsches Klimarechenzentrum GmbH")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY
  "libaec - Adaptive Entropy Coding library")
set(CPACK_PACKAGE_INSTALL_DIRECTORY "libaec")
set(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/../LICENSE.txt")

if(WIN32)
  set(CPACK_GENERATOR "WIX")
  set(CPACK_WIX_UPGRADE_GUID "E58A21F6-BB99-46B5-8AD8-6114E4CCA0A6")
endif()

set(CPACK_SOURCE_IGNORE_FILES /.git;.*~)

include(CPack)

=== src/CMakeLists.txt ===
# Shared and static versions of aec and sz. Also build graec tool for
# internal use.

if(NOT BUILD_SHARED_LIBS AND NOT BUILD_STATIC_LIBS)
  message(FATAL_ERROR
    "At least one out of BUILD_SHARED_LIBS and BUILD_STATIC_LIBS must be selected")
endif()

# Sources for libaec
set(libaec_sources
  encode.c
  encode_accessors.c
  decode.c
  vector.c)

# Properties for all shared and static libraries
macro(aec_common_include aec_target aec_header)
  target_include_directories(${aec_target}
    PUBLIC
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../include>"
    "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/../include>"
    "$<INSTALL_INTERFACE:include>")
  set_target_properties(${aec_target}
    PROPERTIES
    PUBLIC_HEADER "${aec_header}")
endmacro()

# Public header files
set(libaec_header "${CMAKE_CURRENT_BINARY_DIR}/../include/libaec.h")
set(szlib_header "${CMAKE_CURRENT_SOURCE_DIR}/../include/szlib.h")

# Optionally, create both static and shared aec library.
if(BUILD_SHARED_LIBS)
  # Shared libaec
  add_library(aec-shared-objects OBJECT ${libaec_sources})
  aec_common_include(aec-shared-objects "${libaec_header}")
  target_compile_definitions(aec-shared-objects
    PUBLIC "LIBAEC_SHARED"
    PRIVATE "LIBAEC_BUILD")
  add_library(aec-shared SHARED "$<TARGET_OBJECTS:aec-shared-objects>")
  target_link_libraries(aec-shared PUBLIC aec-shared-objects)
  set_target_properties(aec-shared
    PROPERTIES
    VERSION 0.1.4
    SOVERSION 0
    OUTPUT_NAME aec)

  # Shared libsz
  add_library(sz-shared-objects OBJECT sz_compat.c)
  aec_common_include(sz-shared-objects "${szlib_header}")
  target_compile_definitions(sz-shared-objects
    PUBLIC "LIBAEC_SHARED"
    PRIVATE "LIBAEC_BUILD")
  add_library(sz-shared SHARED
    "$<TARGET_OBJECTS:sz-shared-objects>"
    "$<TARGET_OBJECTS:aec-shared-objects>")
  target_link_libraries(sz-shared PUBLIC sz-shared-objects)
  set_target_properties(sz-shared
    PROPERTIES
    VERSION 2.0.1
    SOVERSION 2
    OUTPUT_NAME sz)
  if(MSVC OR ("${CMAKE_C_SIMULATE_ID}" STREQUAL "MSVC"))
    set_target_properties(sz-shared PROPERTIES OUTPUT_NAME szip)
  endif()
  # Add include directory directly to sz-shared so config can get it.
  target_include_directories(sz-shared
    PUBLIC "$<INSTALL_INTERFACE:include>")

  # Aliases for other tools. Prefer shared.
  add_library(libaec::aec ALIAS aec-shared)
  add_library(libaec::sz ALIAS sz-shared)
endif()

if(BUILD_STATIC_LIBS)
  # Static libaec
  add_library(aec-static-objects OBJECT ${libaec_sources})
  aec_common_include(aec-static-objects "${libaec_header}")
  add_library(aec-static STATIC "$<TARGET_OBJECTS:aec-static-objects>")
  target_link_libraries(aec-static PUBLIC aec-static-objects)
  set_target_properties(aec-static PROPERTIES OUTPUT_NAME aec)
  if(MSVC OR ("${CMAKE_C_SIMULATE_ID}" STREQUAL "MSVC"))
    set_target_properties(aec-static PROPERTIES OUTPUT_NAME aec-static)
  endif()

  # Static libsz
  add_library(sz-static-objects OBJECT sz_compat.c)
  aec_common_include(sz-static-objects "${szlib_header}")
  add_library(sz-static STATIC
    "$<TARGET_OBJECTS:sz-static-objects>"
    "$<TARGET_OBJECTS:aec-static-objects>")
  target_link_libraries(sz-static PUBLIC sz-static-objects)
  set_target_properties(sz-static PROPERTIES OUTPUT_NAME sz)
  if(MSVC OR ("${CMAKE_C_SIMULATE_ID}" STREQUAL "MSVC"))
    set_target_properties(sz-static PROPERTIES OUTPUT_NAME szip-static)
  endif()
  # Add include directory directly to sz-static so config can get it.
  target_include_directories(sz-static
    PUBLIC "$<INSTALL_INTERFACE:include>")

  if(NOT BUILD_SHARED_LIBS)
    # Aliases if shared not built.
    add_library(libaec::aec ALIAS aec-static)
    add_library(libaec::sz ALIAS sz-static)
  endif()
endif()

# Simple executable for testing and benchmarking.
add_executable(graec graec.c)
target_link_libraries(graec libaec::aec)

if(UNIX)
  # The shell scripts for benchmarking are supported on unix only
  add_executable(utime EXCLUDE_FROM_ALL utime.c)
  target_include_directories(utime PRIVATE "${CMAKE_CURRENT_BINARY_DIR}/..")
  add_custom_target(bench
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/benc.sh
    ${CMAKE_CURRENT_SOURCE_DIR}/../data/typical.rz
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/bdec.sh
<<<<<<< HEAD
    DEPENDS aec_client utime)
endif()

if(UNIX OR MINGW)
  # Install manpage
  install(
    FILES aec.1
    DESTINATION ${CMAKE_INSTALL_FULL_MANDIR}/man1
    COMPONENT doc)
=======
    DEPENDS graec utime)
>>>>>>> upstream/1.1.1
endif()

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,27 +1,31 @@
 add_library(check_aec STATIC check_aec.c)
-target_link_libraries(check_aec PUBLIC aec)
+target_link_libraries(check_aec PUBLIC libaec::aec)
 
 add_executable(check_code_options check_code_options.c)
-target_link_libraries(check_code_options PUBLIC check_aec aec)
+target_link_libraries(check_code_options PUBLIC check_aec libaec::aec)
 add_test(NAME check_code_options COMMAND check_code_options)
-
 add_executable(check_buffer_sizes check_buffer_sizes.c)
-target_link_libraries(check_buffer_sizes PUBLIC check_aec aec)
+target_link_libraries(check_buffer_sizes PUBLIC check_aec libaec::aec)
 add_test(NAME check_buffer_sizes COMMAND check_buffer_sizes)
 add_executable(check_seeking check_seeking.c)
-target_link_libraries(check_seeking PUBLIC check_aec aec)
+target_link_libraries(check_seeking PUBLIC check_aec libaec::aec)
 add_test(NAME check_seeking COMMAND check_seeking)
 add_executable(check_long_fs check_long_fs.c)
-target_link_libraries(check_long_fs PUBLIC check_aec aec)
+target_link_libraries(check_long_fs PUBLIC check_aec libaec::aec)
 add_test(NAME check_long_fs COMMAND check_long_fs)
 
 add_executable(check_szcomp check_szcomp.c)
-target_link_libraries(check_szcomp PUBLIC check_aec sz)
+target_link_libraries(check_szcomp PUBLIC check_aec libaec::sz)
 add_test(NAME check_szcomp
   COMMAND check_szcomp ${PROJECT_SOURCE_DIR}/data/121B2TestData/ExtendedParameters/sar32bit.dat)
+# On Windows, copy aec.dll and szip.dll to tests directory
+add_custom_command(TARGET check_szcomp POST_BUILD
+  COMMAND ${CMAKE_COMMAND} -E copy -t $<TARGET_FILE_DIR:check_szcomp> $<TARGET_RUNTIME_DLLS:check_szcomp>
+  COMMAND_EXPAND_LISTS
+)
 
 add_executable(check_rsi_block_access check_rsi_block_access.c)
-target_link_libraries(check_rsi_block_access PUBLIC check_aec aec)
+target_link_libraries(check_rsi_block_access PUBLIC check_aec libaec::aec)
 add_test(NAME check_rsi_block_access COMMAND check_rsi_block_access)
 
 if(UNIX)

=== debian/changelog ===
libaec (1.1.4-2) unstable; urgency=medium

  * Push to unstable

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 13 Aug 2025 15:43:15 +0100

libaec (1.1.4-1) experimental; urgency=medium

  * Set Debian Science Maint. as maintainer
  * Standards-Version: 4.7.2; no changes required
  * Drop B-D on dh-buildinfo
  * Drop obsolete pre-depends

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 13 Aug 2025 15:42:54 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,12 @@
 Source: libaec
 Section: utils
 Priority: optional
-Maintainer: Alastair McKinstry <mckinstry@debian.org>
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders: Alastair McKinstry <mckinstry@debian.org>
 Build-Depends: debhelper-compat (= 13),
- dh-buildinfo,
  unzip
 Rules-Requires-Root: no
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Homepage: https://gitlab.dkrz.de/k202009/libaec
 Vcs-Browser: https://salsa.debian.org/science-team/libaec
 Vcs-Git: https://salsa.debian.org/science-team/libaec.git -b debian/latest
@@ -15,7 +15,6 @@
 Section: libs
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Pre-Depends: ${misc:Pre-Depends}
 Multi-Arch: same
 Description: Adaptive Entropy Coding library
  Libaec provides fast lossless compression of 1 up to 32 bit wide
@@ -33,7 +32,6 @@
 Section: libs
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
-Pre-Depends: ${misc:Pre-Depends}
 Multi-Arch: same
 Description: Adaptive Entropy Coding library - SZIP
  Libaec provides fast lossless compression of 1 up to 32 bit wide

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 # The magic debhelper  rule
 %:
-	dh $@ --with autoreconf
+	dh $@
 
 # To enable all, uncomment following line
 DEB_BUILD_MAINT_OPTIONS:= hardening=+all
